SystemOrganization addCategory: #BackgammonView!

Observer subclass: #DieView
	instanceVariableNames: 'dieMorph dieModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!DieView commentStamp: 'AhmedSoliman 7/22/2015 07:36' prior: 0!
I am responsible for observing the Die Model to represent it visually!

!DieView class methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:50'!
dieModel: aModel
	^self new dieModel: aModel
	! !

!DieView methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:51'!
dieModel: aModel
	dieModel := aModel.
	dieModel addObserver: self.	
	! !

!DieView methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:55'!
initialize
	super initialize.
	dieMorph  := DieMorph faces: 6.
	"die2 := DieMorph faces: 6."
	
	dieMorph  openInWorld  .
	"die2 openInWorld."

	
	! !

!DieView methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:46'!
notify
	
	super notify.
	dieMorph  rollDieTo: ( dieModel currentRoll ).
	! !

Morph subclass: #BackgammonBoard
	instanceVariableNames: 'length surface current points checkers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!BackgammonBoard commentStamp: 'DavidOvergaard 7/14/2015 19:08' prior: 0!
This class draws the backgammon board!

!BackgammonBoard class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 21:30'!
createNewBoard
	^BackgammonBoard new openInWorld.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:55'!
addCheckerAtPoint: pointNum color: aColor
	| aChecker pointWidth temp_loc |	
	pointWidth := (((surface width)/17) asInteger).
	temp_loc := (points at: pointNum) location copy.
	temp_loc setX: (temp_loc x) - (pointWidth * 0.9 / 2) setY: (temp_loc y) - (pointWidth * 0.9).
	
	aChecker := BChecker diameter: (pointWidth * 0.9) location: temp_loc color: aColor.
	checkers add: aChecker.
	self addMorph: (aChecker shape).! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:56'!
backgroundColor
	^(Color r: 0.69 g: 0.45 b: 0.26)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:00'!
boardRatio
	^0.75.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:44'!
createBottomPointsWidth: pointWidth height: pointHeight
	| x_loc x_offset y_loc |
		
	x_loc := (surface width) - (pointWidth / 2).
	x_offset := pointWidth * 2.
	x_loc := x_loc - x_offset.
	y_loc := (surface height).
	
	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self evenPointsColor)).
		x_loc := x_loc - pointWidth.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self oddPointsColor)).
		x_loc := x_loc - pointWidth.
	].
	
	x_loc := x_loc - x_offset.
	
	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self evenPointsColor)).
		x_loc := x_loc - pointWidth.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self oddPointsColor)).
		x_loc := x_loc - pointWidth.
	].! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
createPoints
	| pointWidth pointHeight |
	
	points := OrderedCollection new.
	
	pointWidth := (((surface width)/17) asInteger).
	pointHeight := ((surface height / 2) * (-0.9)).
	
	self createBottomPointsWidth: pointWidth height: pointHeight.
	self createTopPointsWidth: pointWidth height: pointHeight.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
createTopPointsWidth: pointWidth height: pointHeight
	| x_loc x_offset y_loc |
	
	x_loc := pointWidth / 2.
	x_offset := (surface width - (16 * pointWidth)).
	x_loc := x_loc + x_offset.
	y_loc := 0.
	
	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self evenPointsColor)).
		x_loc := x_loc + pointWidth.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self oddPointsColor)).
		x_loc := x_loc + pointWidth.
	].

	x_loc := x_loc + (pointWidth * 2).

	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self evenPointsColor)).
		x_loc := x_loc + pointWidth.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self oddPointsColor)).
		x_loc := x_loc + pointWidth.
	].! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 21:38'!
drawOn: aCanvas
	self render.
	
	aCanvas drawImage: surface asForm at: self bounds origin.

"	pointWidth := (((surface width)/17) asInteger).
	temp_loc := (points at: 2) location.
	temp_loc setX: (temp_loc x) - (pointWidth * 0.9 / 2) setY: (temp_loc y) - (pointWidth * 0.9).
	
	checker1 := BChecker diameter: (pointWidth * 0.9) location: temp_loc color: (Color red).
	self addMorph: (checker1 shape)."! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:57'!
evenPointsColor
	^(Color r: 0.93 g: 0.78 b: 0.62)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:00'!
getBoardSize
	"Ratio based on maximum Danish Backgammon Federation tournament size: http://www.bkgm.com/rgb/rgb.cgi?view+842"
	^(self length)@((self boardRatio)*(self length)).! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/18/2015 02:00'!
handlesMouseDown: evt
    ^ true! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:55'!
initialize
	super initialize.
	self length: 1000.
	self extent: (self getBoardSize).
	self color: (self backgroundColor).
	surface := AthensCairoSurface extent: (self extent).
	checkers := OrderedCollection new.

	self createPoints.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:01'!
length
	^length.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:34'!
length: aValue
	length := aValue.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'xl 7/18/2015 02:33'!
mouseUp: t1
	checkers doWithIndex: [ :aChecker  :i|
		(aChecker shape selected)
			ifTrue: [ 
				self moveCheckerNum: i toPoint: 5.
				aChecker shape toggleSelected.
			 ].
		 ].
	^ self! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:46'!
moveCheckerNum: checkerIdx toPoint: pointNum	
	| aChecker pointWidth temp_loc |	
	pointWidth := (((surface width)/17) asInteger).
	temp_loc := ((points at: pointNum) location) copy.
	temp_loc setX: (temp_loc x) - (pointWidth * 0.9 / 2) setY: (temp_loc y) - (pointWidth * 0.9).
	
	aChecker := checkers at: checkerIdx.
	(aChecker shape) position: temp_loc.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:57'!
oddPointsColor
	^(Color r: 0.43 g: 0.31 b: 0.2)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
points
	^points.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
render
	surface drawDuring: [:canvas|
		surface clear: (self backgroundColor).
		
		points do: [ :aPoint |
			canvas setShape: (aPoint shape).
			canvas setPaint: (aPoint color).
			canvas draw.
		 ].
	].! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:00'!
width
	^(length * (self boardRatio)).! !

BorderedMorph subclass: #DieMorph
	instanceVariableNames: 'faces dieValue isStopped counter maxRolls valueToSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!DieMorph commentStamp: 'AhmedSoliman 7/20/2015 07:17' prior: 0!
Class to define the face of the dice!

!DieMorph class methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:18'!
faces: aNumber
	^self new faces: aNumber! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:11'!
dieValue: aNumber
	"method to set the current face value on the dice"
	((aNumber isInteger and: [ aNumber > 0 ]) and: [ aNumber <= faces ])
		ifTrue: [ 
			dieValue := aNumber.
			self changed ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:41'!
drawDotOn: aCanvas at: aPoint
	aCanvas fillOval: (Rectangle center: self position + (self extent * aPoint) extent: self extent / 6) color: Color red borderWidth: 1 borderColor: Color black! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:34'!
drawOn: aCanvas
	| theCanvas |
	theCanvas := aCanvas asAlphaBlendingCanvas: 0.9.
	super drawOn: theCanvas.
	(self perform: ('face' , dieValue asString) asSymbol) do: [ :aPoint | self drawDotOn: theCanvas at: aPoint ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:22'!
face1
	^{0.5@0.5}
! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:23'!
face2
	^{0.25@0.25 . 0.75@0.75}

! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:23'!
face3
	^{0.25@0.25 . 0.75@0.75 . 0.5@0.5}

! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:24'!
face4
	^{0.25@0.25 . 0.75@0.25 . 0.75@0.75 . 0.25@0.75}

! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:24'!
face5
	^{0.25@0.25 . 0.75@0.25 . 0.75@0.75 . 0.25@0.75 . 0.5@0.5}

! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:25'!
face6
	^{0.25@0.25 . 0.75@0.25 . 0.75@0.75 . 0.25@0.75 . 0.25@0.5 . 0.75@0.5}

! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:21'!
faces: aNumber
	"Set the number of faces"

	((aNumber isInteger and: [ aNumber > 0 ]) and: [ aNumber <= 6 ])
		ifTrue: [ faces := aNumber ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:16'!
handlesMouseDown: anEvent
	"^true"
	^false! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:21'!
initialize
	super initialize.
	self extent: 100 @ 100.
	self
		useGradientFill;
		borderWidth: 2;
		useRoundedCorners.
	self setBorderStyle: #complexRaised.
	self fillStyle direction: self extent.
	self color: Color white.
	dieValue := 1.
	maxRolls := 10.
	counter := 0.
	valueToSet := 1.
	faces := 6.
	isStopped := false! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:14'!
mouseDown: anEvent
	anEvent redButtonPressed
		ifTrue: [ isStopped := isStopped not ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:19'!
rollDieTo: aNumber
	"Rolls the die to a specific number"

	valueToSet := aNumber .
	isStopped := false.
	counter := 0.
	self startStepping .	! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:25'!
step
	"a step in the animation as long as the dice did not stop rolling"
	counter := counter + 1.
	counter > maxRolls
		ifTrue: [ isStopped := true. self dieValue: valueToSet ].
	isStopped
		ifFalse: [ self dieValue: (1 to: faces) atRandom ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 08:30'!
stepTime
	"controls the animation lapse time"
	^ 300! !

TestCase subclass: #DieMorphTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!DieMorphTestCase methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/20/2015 07:32'!
testDie
	(DieMorph faces: 6) openInWorld.! !

!DieMorphTestCase methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:27'!
testDieRoll
	|die |
	die := DieMorph faces: 6.
	die openInWorld.
	die rollDieTo: 4.

	die rollDieTo: 2	! !

!DieMorphTestCase methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:29'!
testTwoDiceRoll
	|die1  die2 |
	die1 := DieMorph faces: 6.
	die2 := DieMorph faces: 6.
	
	die1 openInHand .
	die2 openInWorld.

	die1 rollDieTo: 4.
	die2 rollDieTo: 2.	
! !

TestCase subclass: #DieViewTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!DieViewTestCase methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/22/2015 07:51'!
testDie
	|myRoll   myDieModel dieView |
	myDieModel := Dice new.
	
	dieView := DieView dieModel: myDieModel .
	
	myRoll := myDieModel  roll.
	
	Transcript show: myRoll .! !

CircleMorph subclass: #CheckerMorph
	instanceVariableNames: 'selected offsetColor originalColor selectedColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!CheckerMorph commentStamp: '<historical>' prior: 0!
CheckerMorph!

!CheckerMorph class methodsFor: 'as yet unclassified' stamp: 'xl 7/17/2015 23:09'!
createCheckerMorph
	CheckerMorph new openInWorld! !

!CheckerMorph class methodsFor: 'as yet unclassified' stamp: 'xl 7/18/2015 00:28'!
diameter: diameter location: location color: aColor
	^ self new diameter: diameter location: location color: aColor! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/17/2015 22:34'!
click: t1
	Transcript open.
	^ self! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:09'!
diameter: diameter location: location color: aColor
   super initialize.
   super color: aColor.
	originalColor := aColor.
	super borderWidth: 0.
	super extent:diameter@diameter.
	super left: ((location) x).
	super top: ((location) y).
   ^self.! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/17/2015 23:03'!
drawOn: aCanvas
    aCanvas fillOval: self bounds color: (self color).! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/17/2015 23:17'!
handlesMouseDown: evt
    ^ true! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:11'!
initialize
   super initialize.
	super borderWidth: 0.
	super extent:10 @ 10.
   selected := false.
	selectedColor := Color blue.
   ^self.! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:10'!
mouseDown: t1
	self color: selectedColor.
	^ self! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:12'!
mouseUp: t1
	self toggleSelected.
	^ self! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:12'!
onClickExecutionBlock
	self color: offsetColor.! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/18/2015 01:59'!
selected
	^selected! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'xl 7/18/2015 02:29'!
selected: aBool
	selected:=aBool! !

!CheckerMorph methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/18/2015 12:10'!
toggleSelected
	"self position: self position + (50 @ 0)."
	(selected)
		ifTrue: [
			self color: originalColor.
			self selected:false.
		]
		ifFalse: [
			self color: selectedColor.
			self selected:true.
		].! !

Object subclass: #BackgammonPoint
	instanceVariableNames: 'location shape color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!BackgammonPoint commentStamp: 'DavidOvergaard 7/14/2015 20:02' prior: 0!
A backgammon point!

!BackgammonPoint class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:00'!
width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp
	^BackgammonPoint new width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp.! !

!BackgammonPoint class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:22'!
width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp color: aColor
	^BackgammonPoint new width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp color: aColor.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:23'!
color
	^color! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 22:53'!
initialize
	super initialize.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:10'!
location
	^location! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:02'!
shape
	^shape! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:09'!
width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp
	| surface |
	
	location := centerLocation.
	
	"Need a surface to use shape creation"
	surface := AthensCairoSurface extent: 0@0.

	shape := surface createPath: [:builder |
		builder 
			moveTo: centerLocation;
			lineTo: (pointWidth/2)@0;
			lineTo: (-1*(pointWidth/2))@(pointHeight * pointsUp);
			lineTo: (-1*pointWidth/2)@(-1 * (pointHeight * pointsUp));
			close
		].! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:23'!
width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp color: aColor
	| surface |
	
	location := centerLocation.
	color := aColor.
	
	"Need a surface to use shape creation"
	surface := AthensCairoSurface extent: 0@0.

	shape := surface createPath: [:builder |
		builder 
			moveTo: centerLocation;
			lineTo: (pointWidth/2)@0;
			lineTo: (-1*(pointWidth/2))@(pointHeight * pointsUp);
			lineTo: (-1*pointWidth/2)@(-1 * (pointHeight * pointsUp));
			close
		].! !
